#!/usr/bin/perl -w
#
# (c) LinuxMagic Inc. 2004 All Rights Reserved.
#
# $Id: update_lists.pl,v 1.5 2004/09/28 17:46:24 josh Exp $
#

#
# CONFIG
#

$incoming = '/var/cache/bms/incoming';
$listdir = '/var/cache/bms';
$url = 'http://www.linuxmagic.com/updates/blocklists/';
$command='/usr/bin/curl';

#
# END CONFIG
#

# make sure listdir and incoming end with '/'
if ($listdir !~ m/\/$/) {
    $listdir .= "/";
}
if ($incoming !~ m/\/$/) {
    $incoming .= "/";
}

# Forgot to check to see if this file is there before assigning
# it to a variable below..
# Might want to make this handler better
#
if ( ! -x $command ) {
        print STDERR "FATAL: Missing executable, [$command]\n";
	exit (1);
}

if (( ! -d $listdir ) || ( ! -d $incoming )) {
    print STDERR "FATAL: Unable to update block lists, output dir does not exist.\n";
    exit (1);
}

$filelist=`curl --connect-timeout 10 -sS $url`;

my @files;
while ($filelist =~ s/^.*?href=\"([^\"]*)\"//s) {
    $file = $1;
    chomp($file);
    if ((length($file) > 0) && ($file =~ m/.bz2$/)) {
    	push (@files, $file);
    }
}

foreach $file (@files) {
    @oldstatinfo = stat("$incoming$file");
    system("$command -sS --connect-timeout 10 --time-cond $incoming$file -o $incoming$file $url$file"); 
    @newstatinfo = stat("$incoming$file");

    # see if size (7) or mtime (9) have changed
    if (@newstatinfo) {
    	if (!@oldstatinfo
    		|| ($oldstatinfo[7] != $newstatinfo[7]) 
		|| ($oldstatinfo[9] != $newstatinfo[9])) {

	    $outfile = $file;
	    $outfile =~ s/\.bz2$//;

	    system("bunzip2 -k $incoming$file && mv $incoming$outfile $listdir$outfile");
	    print "Updated list $outfile\n";
    	}
    }
}

